<script lang="ts">
	import { onMount, onDestroy } from 'svelte';
	import type { LeafletEvent, Map, TileLayer } from 'leaflet';
	import 'leaflet/dist/leaflet.css';
	import { latLngBoundsToRequestModel } from '$lib/geodata_conversion';
	import { json } from '@sveltejs/kit';
	import * as L from 'leaflet';

	let mapElement: HTMLElement;
	export let geojsonFeatureCollection: GeoJSON.FeatureCollection | undefined;
	let map: Map;
	let tileLayer: TileLayer | undefined = undefined;
	let markerLayerGroup: L.LayerGroup;

	onMount(async () => {
		map = L.map(mapElement).setView([47.376888, 8.541694], 12);
		markerLayerGroup = L.layerGroup().addTo(map);

		tileLayer = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
			attribution:
				'&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
		});
		tileLayer.addTo(map);

		map.on('moveend', onMoveEndChange);
		testMapRouting();
	});

	onDestroy(async () => {
		if (map) {
			map.remove();
		}
	});

	// fetches new GeoJSON FeatureCollections on zoom and end of Move Change
	const onMoveEndChange = async (event: LeafletEvent) => {
		if (event.target._zoom >= 17) {
			// Fetch New Data
			const bounds = map.getBounds();
			const requestModel = latLngBoundsToRequestModel(bounds);
			// TODO cleanup into own file with all requests
			const response = await fetch('http://localhost:8080/api/v1/geometry/bbx', {
				method: 'POST',
				body: JSON.stringify(requestModel),
				headers: {
					'Content-Type': 'application/json'
				}
			});
			const r = await response.json();
			const answer: GeoJSON.Feature[] = r.map((e) => {
				return JSON.parse(e.geojson) as GeoJSON.Feature;
			});
			const geojsonFeatureCollection: GeoJSON.FeatureCollection = {
				features: answer,
				type: 'FeatureCollection'
			};
			// clear all data of previous request
			markerLayerGroup.clearLayers();
			// add new markers
			//L.geoJSON(d).addTo(markerLayerGroup);
			var geojsonMarkerOptions = {
				radius: 8,
				fillColor: '#ff7800',
				color: '#000',
				weight: 1,
				opacity: 1,
				fillOpacity: 0.8
			};
			L.geoJSON(geojsonFeatureCollection, {
				pointToLayer: function (feature, latlng) {
					return L.circleMarker(latlng, geojsonMarkerOptions);
				},
				onEachFeature: function (feature, layer) {
					console.log(layer);
					layer.bindPopup(
						`Art:${feature.properties.art_txt}, NISNR: ${feature.properties.nisnr}, Orientierung: ${feature.properties.orientierung}, ObjID${feature.properties.objid}`
					);
				}
			}).addTo(markerLayerGroup);
		} else {
			console.log('not zommed in enough');
		}
	};

	async function testMapRouting() {
		const latlngPoints = await fetch('/navigation', { method: 'POST' });
		var polyline = L.polyline(await latlngPoints.json(), { color: 'red' }).addTo(map);
	}
</script>

<main>
	<div bind:this={mapElement} />
</main>

<style>
	@import 'leaflet/dist/leaflet.css';
	main div {
		position: absolute;
		top: 0;
		bottom: 0;
		width: 100%;
	}
</style>
